<html>
<head>
<title>Ogre::PageManager::EventRouter Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1PageManager.html">PageManager</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1PageManager_1_1EventRouter.html">EventRouter</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::PageManager::EventRouter Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::PageManager::EventRouter" --><!-- doxytag: inherits="Ogre::Camera::Listener,Ogre::FrameListener" -->
<p><code>#include &lt;<a class="el" href="OgrePageManager_8h_source.html">OgrePageManager.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::PageManager::EventRouter:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1PageManager_1_1EventRouter__inherit__graph.gif" border="0" usemap="#Ogre_1_1PageManager_1_1EventRouter_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1PageManager_1_1EventRouter_inherit__map" id="Ogre_1_1PageManager_1_1EventRouter_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1Camera_1_1Listener.html" title="Listener interface so you can be notified of Camera events." alt="" coords="5,5,163,35"/><area shape="rect" id="node4" href="classOgre_1_1FrameListener.html" title="A interface class defining a listener which can be used to receive notifications of frame events..." alt="" coords="187,5,328,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1PageManager_1_1EventRouter-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PageManager_1_1EventRouter.html#a63608f4f61d458464e5752548c2b9be0">EventRouter</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PageManager_1_1EventRouter.html#a2b011465b3527e909ea2ceb5ef121df4">~EventRouter</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PageManager_1_1EventRouter.html#a4bf9a554da6e38a6c5cb2e325c7a118f">cameraPreRenderScene</a> (<a class="el" href="classOgre_1_1Camera.html">Camera</a> *cam)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called prior to the scene being rendered with this camera.  <a href="#a4bf9a554da6e38a6c5cb2e325c7a118f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PageManager_1_1EventRouter.html#a0b8a3b8a5dfad12e3abb4fa9e0cb47f1">cameraDestroyed</a> (<a class="el" href="classOgre_1_1Camera.html">Camera</a> *cam)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called when the camera is being destroyed.  <a href="#a0b8a3b8a5dfad12e3abb4fa9e0cb47f1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PageManager_1_1EventRouter.html#ac2ad1b3783610d5c669f6ebb29a5f866">frameStarted</a> (const <a class="el" href="structOgre_1_1FrameEvent.html">FrameEvent</a> &amp;evt)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called when a frame is about to begin rendering.  <a href="#ac2ad1b3783610d5c669f6ebb29a5f866"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PageManager_1_1EventRouter.html#a823feb29579d463117fdb0417d49a100">frameEnded</a> (const <a class="el" href="structOgre_1_1FrameEvent.html">FrameEvent</a> &amp;evt)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called just after a frame has been rendered.  <a href="#a823feb29579d463117fdb0417d49a100"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Camera_1_1Listener.html#a9359c80e745123e503311edbfc1d829a">cameraPostRenderScene</a> (<a class="el" href="classOgre_1_1Camera.html">Camera</a> *cam)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called after the scene has been rendered with this camera.  <a href="#a9359c80e745123e503311edbfc1d829a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FrameListener.html#a2785cb38589ab9df123fa401cbda31c3">frameRenderingQueued</a> (const <a class="el" href="structOgre_1_1FrameEvent.html">FrameEvent</a> &amp;evt)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called after all render targets have had their rendering commands issued, but before render windows have been asked to flip their buffers over.  <a href="#a2785cb38589ab9df123fa401cbda31c3"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1PageManager.html">PageManager</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PageManager_1_1EventRouter.html#a2b4ffddff449189daef52fb4c1838f67">pManager</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1PageManager.html#a0efade4e6f7cee4cd83eee27e072a972">WorldMap</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PageManager_1_1EventRouter.html#a0932e09218ac4f4af94a19c89a3eeb85">pWorldMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1PageManager.html#a64ddd908be3b3b1798835b23325a10cb">CameraList</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PageManager_1_1EventRouter.html#a8b7284a3c24b60fc0631273f68051cff">pCameraList</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock">
<p>Definition at line <a class="el" href="OgrePageManager_8h_source.html#l00440">440</a> of file <a class="el" href="OgrePageManager_8h_source.html">OgrePageManager.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a63608f4f61d458464e5752548c2b9be0"></a><!-- doxytag: member="Ogre::PageManager::EventRouter::EventRouter" ref="a63608f4f61d458464e5752548c2b9be0" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1PageManager_1_1EventRouter.html#a63608f4f61d458464e5752548c2b9be0">Ogre::PageManager::EventRouter::EventRouter</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgrePageManager_8h_source.html#l00447">447</a> of file <a class="el" href="OgrePageManager_8h_source.html">OgrePageManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a2b011465b3527e909ea2ceb5ef121df4"></a><!-- doxytag: member="Ogre::PageManager::EventRouter::~EventRouter" ref="a2b011465b3527e909ea2ceb5ef121df4" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1PageManager_1_1EventRouter.html#a2b011465b3527e909ea2ceb5ef121df4">Ogre::PageManager::EventRouter::~EventRouter</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgrePageManager_8h_source.html#l00448">448</a> of file <a class="el" href="OgrePageManager_8h_source.html">OgrePageManager.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a0b8a3b8a5dfad12e3abb4fa9e0cb47f1"></a><!-- doxytag: member="Ogre::PageManager::EventRouter::cameraDestroyed" ref="a0b8a3b8a5dfad12e3abb4fa9e0cb47f1" args="(Camera *cam)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1PageManager_1_1EventRouter.html#a0b8a3b8a5dfad12e3abb4fa9e0cb47f1">Ogre::PageManager::EventRouter::cameraDestroyed</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Camera.html">Camera</a> *&#160;</td>
          <td class="paramname"><em>cam</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Called when the camera is being destroyed. </p>

<p>Reimplemented from <a class="el" href="classOgre_1_1Camera_1_1Listener.html#a7195d8b8c12193eda52cc747262bd35b">Ogre::Camera::Listener</a>.</p>

</div>
</div>
<a class="anchor" id="a9359c80e745123e503311edbfc1d829a"></a><!-- doxytag: member="Ogre::PageManager::EventRouter::cameraPostRenderScene" ref="a9359c80e745123e503311edbfc1d829a" args="(Camera *cam)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1Camera_1_1Listener.html#a9359c80e745123e503311edbfc1d829a">Ogre::Camera::Listener::cameraPostRenderScene</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Camera.html">Camera</a> *&#160;</td>
          <td class="paramname"><em>cam</em></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Called after the scene has been rendered with this camera. </p>

<p>Definition at line <a class="el" href="OgreCamera_8h_source.html#l00101">101</a> of file <a class="el" href="OgreCamera_8h_source.html">OgreCamera.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4bf9a554da6e38a6c5cb2e325c7a118f"></a><!-- doxytag: member="Ogre::PageManager::EventRouter::cameraPreRenderScene" ref="a4bf9a554da6e38a6c5cb2e325c7a118f" args="(Camera *cam)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1PageManager_1_1EventRouter.html#a4bf9a554da6e38a6c5cb2e325c7a118f">Ogre::PageManager::EventRouter::cameraPreRenderScene</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Camera.html">Camera</a> *&#160;</td>
          <td class="paramname"><em>cam</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Called prior to the scene being rendered with this camera. </p>

<p>Reimplemented from <a class="el" href="classOgre_1_1Camera_1_1Listener.html#a118a99ab616bd2e1648c335afda174c9">Ogre::Camera::Listener</a>.</p>

</div>
</div>
<a class="anchor" id="a823feb29579d463117fdb0417d49a100"></a><!-- doxytag: member="Ogre::PageManager::EventRouter::frameEnded" ref="a823feb29579d463117fdb0417d49a100" args="(const FrameEvent &amp;evt)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1PageManager_1_1EventRouter.html#a823feb29579d463117fdb0417d49a100">Ogre::PageManager::EventRouter::frameEnded</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1FrameEvent.html">FrameEvent</a> &amp;&#160;</td>
          <td class="paramname"><em>evt</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Called just after a frame has been rendered. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This event happens after all render targets have been fully updated and the buffers switched. </dd></dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>True to continue with the next frame, false to drop out of the rendering loop. </dd></dl>

<p>Reimplemented from <a class="el" href="classOgre_1_1FrameListener.html#af1d0140678c18a013ac45aa544c00bfd">Ogre::FrameListener</a>.</p>

</div>
</div>
<a class="anchor" id="a2785cb38589ab9df123fa401cbda31c3"></a><!-- doxytag: member="Ogre::PageManager::EventRouter::frameRenderingQueued" ref="a2785cb38589ab9df123fa401cbda31c3" args="(const FrameEvent &amp;evt)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1FrameListener.html#a2785cb38589ab9df123fa401cbda31c3">Ogre::FrameListener::frameRenderingQueued</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1FrameEvent.html">FrameEvent</a> &amp;&#160;</td>
          <td class="paramname"><em>evt</em></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Called after all render targets have had their rendering commands issued, but before render windows have been asked to flip their buffers over. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>The usefulness of this event comes from the fact that rendering commands are queued for the GPU to process. These can take a little while to finish, and so while that is happening the CPU can be doing useful things. Once the request to 'flip buffers' happens, the thread requesting it will block until the GPU is ready, which can waste CPU cycles. Therefore, it is often a good idea to use this callback to perform per-frame processing. Of course because the frame's rendering commands have already been issued, any changes you make will only take effect from the next frame, but in most cases that's not noticeable. </dd></dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>True to continue rendering, false to drop out of the rendering loop. </dd></dl>

<p>Definition at line <a class="el" href="OgreFrameListener_8h_source.html#l00119">119</a> of file <a class="el" href="OgreFrameListener_8h_source.html">OgreFrameListener.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac2ad1b3783610d5c669f6ebb29a5f866"></a><!-- doxytag: member="Ogre::PageManager::EventRouter::frameStarted" ref="ac2ad1b3783610d5c669f6ebb29a5f866" args="(const FrameEvent &amp;evt)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1PageManager_1_1EventRouter.html#ac2ad1b3783610d5c669f6ebb29a5f866">Ogre::PageManager::EventRouter::frameStarted</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1FrameEvent.html">FrameEvent</a> &amp;&#160;</td>
          <td class="paramname"><em>evt</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Called when a frame is about to begin rendering. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This event happens before any render targets have begun updating. </dd></dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>True to go ahead, false to abort rendering and drop out of the rendering loop. </dd></dl>

<p>Reimplemented from <a class="el" href="classOgre_1_1FrameListener.html#a88238b65f9ce32f0de8c5eeeb7b6c6ad">Ogre::FrameListener</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a8b7284a3c24b60fc0631273f68051cff"></a><!-- doxytag: member="Ogre::PageManager::EventRouter::pCameraList" ref="a8b7284a3c24b60fc0631273f68051cff" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1PageManager.html#a64ddd908be3b3b1798835b23325a10cb">CameraList</a>* <a class="el" href="classOgre_1_1PageManager_1_1EventRouter.html#a8b7284a3c24b60fc0631273f68051cff">Ogre::PageManager::EventRouter::pCameraList</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgrePageManager_8h_source.html#l00445">445</a> of file <a class="el" href="OgrePageManager_8h_source.html">OgrePageManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a2b4ffddff449189daef52fb4c1838f67"></a><!-- doxytag: member="Ogre::PageManager::EventRouter::pManager" ref="a2b4ffddff449189daef52fb4c1838f67" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1PageManager.html">PageManager</a>* <a class="el" href="classOgre_1_1PageManager_1_1EventRouter.html#a2b4ffddff449189daef52fb4c1838f67">Ogre::PageManager::EventRouter::pManager</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgrePageManager_8h_source.html#l00443">443</a> of file <a class="el" href="OgrePageManager_8h_source.html">OgrePageManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a0932e09218ac4f4af94a19c89a3eeb85"></a><!-- doxytag: member="Ogre::PageManager::EventRouter::pWorldMap" ref="a0932e09218ac4f4af94a19c89a3eeb85" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1PageManager.html#a0efade4e6f7cee4cd83eee27e072a972">WorldMap</a>* <a class="el" href="classOgre_1_1PageManager_1_1EventRouter.html#a0932e09218ac4f4af94a19c89a3eeb85">Ogre::PageManager::EventRouter::pWorldMap</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgrePageManager_8h_source.html#l00444">444</a> of file <a class="el" href="OgrePageManager_8h_source.html">OgrePageManager.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgrePageManager_8h_source.html">OgrePageManager.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:11
</p>
</body>
</html>
